package com.sagacloud.utils;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Created by wo on 5/2/18.
 */
public class VendersUtil {

    public static JSONObject successJsonMsg(String msg) {
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("result", "success");
        jsonObj.put("resultMsg", msg);
        return jsonObj;
    }

    public static JSONObject successJsonMsg(String msg, Object pojo){
        JSONObject obj = new JSONObject();
        if(pojo != null){
            obj = (JSONObject) JSONObject.toJSON(pojo);
        }
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("result", "success");
        jsonObj.put("resultMsg", msg);
        jsonObj.put("content",obj);
        return jsonObj;
    }

    public static JSONObject successJsonMsg(String msg, List list) {
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("result", "success");
        jsonObj.put("count",list.size());
        jsonObj.put("content",new JSONArray(list));
        jsonObj.put("resultMsg", msg);
        return jsonObj;
    }
    public static JSONObject successJsonMsg(String msg, JSONArray arr){
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("result", "success");
        jsonObj.put("count",arr.size());
        jsonObj.put("content",arr);
        jsonObj.put("resultMsg", msg);
        return jsonObj;
    }
    public static JSONObject errorJsonMsg(String msg) {
        JSONObject jsonObj = new JSONObject();
        jsonObj.put("result", "failure");
        jsonObj.put("resultMsg", msg);
        return jsonObj;
    }

    public static Set<String> createSet(String... elements) {
        Set<String> set = new HashSet<>();
        for (String e : elements) {
            set.add(e);
        }
        return set;
    }

    public static Set<Object> getInfoSet(JSONArray content, String infoCode) {
        Set<Object> set = new HashSet<>();
        if(content == null)
            return set;
        for(int i = 0; i < content.size(); ++i){
            JSONObject single = content.getJSONObject(i);
            if(single == null)
                continue;
            JSONObject infos = single.getJSONObject("infos");
            if(infos == null)
                continue;
            Object value = infos.get(infoCode);
            if(value == null)
                continue;
            if(!set.contains(value))
                set.add(value);
        }
        return set;
    }
}
